<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../lib/Grob.js"></script>
    <script src="../lib/Line.js"></script>
    <script src="../lib/LinesGroup.js"></script>
    <script src="../lib/Canvas.js"></script>

  </head>
  <body>

    <script>

    class MockShape {
        constructor (x,w) { this.x = x; this.w = w  ;}
        set text (text) {}
        show(){}
        contains(x){return this.x <= x && x <= this.x + this.w}
    }

    class MockView {
        constructor () {
            this.height = 300
        }
        changeHeightIfNeeded (y) {
            return y;
        }
        createRectangle(x, y, width, height) {
            return new MockShape ()
        }
        addSpaceAtTop (h) {}
    }

    const GROUP_TOP = 96

    suite('Canvas', () => {

        // Canvas.lineOn do not exist anymore so the following cannot be executed
        //
        // suite ('->constructor', () => {
        //
        //     setup (() => {
        //         this.view = new MockView()
        //         this.canvas = new Canvas(this.view);
        //     })
        //
        //     test('should create a unique line fitting the view', () => {
        //         let line = canvas.lineOn(100)
        //         assert.equal(line.top, 0)
        //         assert.equal(line.bottom, 300)
        //     })
        //
        //     test('should create a unique line fitting the view enven if view height grows up', () => {
        //         this.view.height = 500
        //         let line = this.canvas.lineOn(100)
        //         assert.equal(line.top, 0)
        //         assert.equal(line.bottom, 500)
        //     })
        //
        //     test('should create a unique line fitting the view enven if view height grows down', () => {
        //         this.view.height = 200
        //         let line = this.canvas.lineOn(100)
        //         assert.equal(line.top, 0)
        //         assert.equal(line.bottom, 200)
        //     })
        //
        // })

        suite ('->add', () => {

            setup (() => {
                this.view = new MockView()
                this.canvas = new Canvas(this.view);
                this.grob = new Grob(100, 100, new MockShape(100, 100));
            })

            test ('should add a grob', () => {
              this.canvas.updateOrAddLines([{"top" : 50, "bottom": 150}])
              this.canvas.add(this.grob).on(100 + GROUP_TOP);
              assert.ok(this.grob.equalTo(this.canvas.grobOn(100,100 + GROUP_TOP)))
            })

            // cannot use Canvas.add() to add a line anymore
            // test ('should add a line', () => {
            //     let line = new Line(50, 150, this.group);
            //     this.canvas.add(line);
            //     assert.ok(line.equalTo(this.canvas.lineOn(100)));
            // })

        })

        // Canvas.lineOn do not exist anymore so the following cannot be executed
        //
        // suite ('->lineOn', () => {
        //
        //     setup (() => {
        //         this.canvas = new Canvas(new MockView());
        //         this.line = new Line(50, 150, { top: 0 });
        //         this.canvas.add(this.line);
        //     })
        //
        //     test ('should return the line just added', () => {
        //         assert.ok(this.line.equalTo(this.canvas.lineOn(100)));
        //     })
        //
        //     test ('should not find line if y is above', () => {
        //         assert.equal(this.canvas.lineOn(20), undefined);
        //     })
        //
        //     test ('should not find line if y is below', () => {
        //         assert.equal(this.canvas.lineOn(200), undefined);
        //     })
        //
        // })

        suite ('->grobOn', () => {

            setup (() => {
                this.canvas = new Canvas(new MockView());
                this.grob = new Grob(100, 100, new MockShape(100, 100));
            })

            test('should return the grob just added', () => {
              this.canvas.updateOrAddLines([{"top" : 50, "bottom": 150}])
              this.canvas.add(this.grob).on(100 + GROUP_TOP);
              assert.ok(this.grob.equalTo(this.canvas.grobOn(100,100 + GROUP_TOP)))
            })

            test('should return null if no grob is found', () => {
              this.canvas.updateOrAddLines([{"top" : 50, "bottom": 150}])
              this.canvas.add(this.grob).on(100 + GROUP_TOP);
              assert.isUndefined(this.canvas.grobOn(10,10 + GROUP_TOP))
            })

            test('should return a grob if no line exists on y but the grob is on the lines above and below', () => {
              this.canvas.updateOrAddLines([
                {"top" : 50, "bottom": 150},
                {"top" : 200, "bottom": 300}
              ])
              this.canvas.add(this.grob).on(100 + GROUP_TOP);
              this.canvas.add(this.grob).on(250 + GROUP_TOP);
              assert.ok(this.grob.equalTo(this.canvas.grobOn(100,180 + GROUP_TOP)))
            })

            test('should not return a grob if no line exists on y and grob is on the line above and a other is on the line below', () => {
              this.canvas.updateOrAddLines([
                {"top" : 50, "bottom": 150},
                {"top" : 200, "bottom": 300}
              ])
              this.canvas.add(this.grob).on(100 + GROUP_TOP);
              this.canvas.add(new Grob(100, 100, new MockShape(100, 100))).on(250 + GROUP_TOP);
              assert.isUndefined(this.canvas.grobOn(100,180 + GROUP_TOP));
            })

            // useless tests?
            //
            // test('should not return a grob if no line exists on y there is no line below', () => {
            //     assert.isUndefined(this.canvas.grobOn(100,180));
            // })
            //
            // test('should not return a grob if no line exists on y there is no line above', () => {
            //     assert.isUndefined(this.canvas.grobOn(100,40));
            // })

            test('should return a grob when several grobs are on the same below line at same x', () => {
              this.canvas.updateOrAddLines([
                {"top" : 100, "bottom": 200},
                {"top" : 300, "bottom": 400}
              ])
              let grob1 = new Grob(100, 100, new MockShape(100, 100))
              let grob2 = new Grob(80, 100, new MockShape(100, 100))
              this.canvas.add(grob1).on(150 + GROUP_TOP);
              this.canvas.add(grob2).on(150 + GROUP_TOP);
              this.canvas.add(grob1).on(350 + GROUP_TOP);
              assert.ok(grob1.equalTo(canvas.grobOn(150,250 + GROUP_TOP)))
            })

        });

        suite ('->getChildrenFrom', () => {

            setup (() => {
                this.canvas = new Canvas(new MockView())
                this.canvas.updateOrAddLines([
                  {"top" : 50, "bottom": 100},
                  {"top" : 150, "bottom": 200},
                  {"top" : 250, "bottom": 300},
                  {"top" : 350, "bottom": 400}
                ])
            })

            function check () {
                assert.equal(this.children.length, 2)
                assert.ok(this.children[0].equalTo(new Line(150 + GROUP_TOP, 200 + GROUP_TOP)))
                assert.ok(this.children[1].equalTo(new Line(250 + GROUP_TOP, 300 + GROUP_TOP)))
            }

            test('should return children', () => {
                this.children = this.canvas.getChildrenFrom(120 + GROUP_TOP).to(320 + GROUP_TOP)
                check()
            })

            test('should return children if line top and bottom are equal to given top and bottom', () => {
                this.children = canvas.getChildrenFrom(150 + GROUP_TOP).to(300 + GROUP_TOP)
                check()
            })

            test('should return children if a line is on the given top', () => {
                this.children = canvas.getChildrenFrom(180 + GROUP_TOP).to(300 + GROUP_TOP)
                check()
            })

            test('should return children if a line is on the given bottom', () => {
                this.children = canvas.getChildrenFrom(150 + GROUP_TOP).to(280 + GROUP_TOP)
                check()
            })

            test('should not return children when given top and bottom are between 2 adjacent lines', () => {
                let children = canvas.getChildrenFrom(110 + GROUP_TOP).to(140 + GROUP_TOP)
                assert.equal(children.length, 0)
            })

        })

        suite ('->add.onLineIndex', () => {

            test ('NOT TESTED YET!!', () => {})

        })
    });

    </script>

  </body>
</html>
